searchData={"content_type":"text/markdown","items":[{"doc":"Precuter helps to implement decorators on your functions\n\nWhat is a decorator? basicaly a function that you can run before, or after the call of a function, in order to\nadd stats, or validations or just to log something before the call\n\nThe point of this library it's not break your mind learning complex concepts about how to create decorators\n\nAll are just simple functions, simple modules, nothing to implement, just a module, a function with arguments and just\na simple use of the module `Precuter`","ref":"Precuter.html","title":"Precuter","type":"module"},{"doc":"```elixir\n  defmodule ModuleTest do\n    use Precuter\n\n    # just use the module attribute `@precuter` and set the mfa (module, function, arguments) or a keyword with the all the mfa with every step\n    # you can use the atom `:args` to send to your functions the arguments of the function call in a list of arguments\n\n    @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n    def example_func(some_number) do\n      some_number * 2\n    end\n  end\n  ```","ref":"Precuter.html#module-basic-usage","title":"Basic usage - Precuter","type":"module"},{"doc":"You can set 3 callbacks, before run, after run, and a middle step that you can use to define if run or not your function\n\n  ```elixir\n  @precuter [\n    pre: {SomeModule, :some_func_pre, [:an_arg, :args]},\n    cond: {SomeModule, :some_func_cond_fails, [:args]},\n    post: {SomeModule, :some_func_post, [:an_post_arg]}\n  ]\n  ```","ref":"Precuter.html#module-options","title":"Options - Precuter","type":"module"},{"doc":"Exist some limitations with the decorators, like use pattern matching or different arity functions, this it's a work\nin progress so in future updates you will be able to implement decorators on functions with different arity\n\n#### DON'T DO THIS\n\n  ```elixir\n  defmodule ModuleTest do\n    use Precuter\n\n    @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n    def example_func(some_number) when is_number(some_number) do\n      some_number * 2\n    end\n\n    @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n    def example_func(other_values) do\n      other_values\n    end\n  end\n  ```","ref":"Precuter.html#module-considerations","title":"Considerations - Precuter","type":"module"},{"doc":"","ref":"Precuter.html#empty/0","title":"Precuter.empty/0","type":"function"},{"doc":"","ref":"Precuter.Args.html","title":"Precuter.Args","type":"module"},{"doc":"","ref":"Precuter.Args.html#purify_args/1","title":"Precuter.Args.purify_args/1","type":"function"},{"doc":"","ref":"Precuter.Function.html","title":"Precuter.Function","type":"module"},{"doc":"","ref":"Precuter.Function.html#generate_reimplemented_func/4","title":"Precuter.Function.generate_reimplemented_func/4","type":"function"},{"doc":"","ref":"Precuter.Function.html#generate_replacement_func/5","title":"Precuter.Function.generate_replacement_func/5","type":"function"},{"doc":"","ref":"Precuter.Function.html#get_body/3","title":"Precuter.Function.get_body/3","type":"function"},{"doc":"# Precuter\n\nPrecuter helps to implement decorators on your functions\n\nWhat is a decorator? basicaly a function that you can run before, or after the call of a function, in order to\nadd stats, or validations or just to log something before the call\n\nThe point of this library it's not break your mind learning complex concepts about how to create decorators\n\nAll are just simple functions, simple modules, nothing to implement, just a module, a function with arguments and just\na simple use of the module `Precuter`","ref":"readme.html","title":"Precuter","type":"extras"},{"doc":"If [available in Hex](https://hexdocs.pm/precuter), the package can be installed\nby adding `precuter` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:precuter, \"~> 0.1.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Precuter","type":"extras"},{"doc":"```elixir\ndefmodule ModuleTest do\n  use Precuter\n\n  # just use the module attribute `@precuter` and set the mfa (module, function, arguments) or a keyword with the all the mfa with every step\n  # you can use the atom `:args` to send to your functions the arguments of the function call in a list of arguments\n\n  @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n  def example_func(some_number) do\n    some_number * 2\n  end\nend\n```","ref":"readme.html#basic-usage","title":"Basic usage - Precuter","type":"extras"},{"doc":"You can set 3 callbacks, before run, after run, and a middle step that you can use to define if run or not your function\n\n```elixir\n@precuter [\n  pre: {SomeModule, :some_func_pre, [:an_arg, :args]},\n  cond: {SomeModule, :some_func_cond_fails, [:args]},\n  post: {SomeModule, :some_func_post, [:an_post_arg]}\n]\n```","ref":"readme.html#options","title":"Options - Precuter","type":"extras"},{"doc":"Exist some limitations with the decorators, like use pattern matching or different arity functions, this it's a work\nin progress so in future updates you will be able to implement decorators on functions with different arity\n\n#### DON'T DO THIS\n\n```elixir\ndefmodule ModuleTest do\n  use Precuter\n\n  @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n  def example_func(some_number) when is_number(some_number) do\n    some_number * 2\n  end\n\n  @precuter {SomeModule, :some_function, [:some_static_arg, 1, :args]}\n  def example_func(other_values) do\n    other_values\n  end\nend\n```","ref":"readme.html#considerations","title":"Considerations - Precuter","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}